package be.iminds.ilabt.jfed.highlevel.tasks;

import be.iminds.ilabt.jfed.fedmon.webapi.service.json.Server;
import be.iminds.ilabt.jfed.highlevel.controller.JFedHighLevelException;
import be.iminds.ilabt.jfed.highlevel.controller.Task;
import be.iminds.ilabt.jfed.highlevel.controller.TaskExecution;
import be.iminds.ilabt.jfed.highlevel.model.Slice;
import be.iminds.ilabt.jfed.highlevel.model.Sliver;
import be.iminds.ilabt.jfed.highlevel.util.AggregateManagerWrapperFactory;
import be.iminds.ilabt.jfed.lowlevel.connection.JFedException;
import be.iminds.ilabt.jfed.lowlevel.api_wrapper.AggregateManagerWrapper;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.net.URL;
import java.util.Collections;
import java.util.List;

public class OpenConsoleTask extends PoaTask {
    private URL url = null;

    public OpenConsoleTask(@Nonnull Sliver sliver,
                           @Nonnull AggregateManagerWrapperFactory aggregateManagerWrapperFactory,
                           @Nonnull HighLevelTaskFactory highLevelTaskFactory) {
        super("Get Console URL for sliver " + sliver.getUrn(),
                sliver.getSlice(), sliver.getServer(), sliver.getUrn(),
                aggregateManagerWrapperFactory, highLevelTaskFactory);
    }

    @Override
    public void doPoaAction(@Nonnull AggregateManagerWrapper amWrapper) throws JFedException {
        this.url = amWrapper.openConsole(poaTarget, slice.getCredentials());
    }

    @Nullable
    public URL getUrl() {
        return url;
    }
}
